Subject: [bug#27661] ISO-9660 image working and ready

From: Danny Milosavljevic <[email-masked]>
Date: Fri, 14 Jul 2017 09:30:21 +0200

Hi Marius,

On Thu, 13 Jul 2017 20:53:50 +0200
Marius Bakke <[email-masked]> wrote:

> It does not work on UEFI. I tested in qemu like this:
> 
> qemu-system-x86_64 -bios $(guix build ovmf)/share/firmware/ovmf_x64.bin \
>   -m 256M -enable-kvm -boot c -cdrom /gnu/store/...-disk-image/guixsd.iso
> 
> There doesn't seem to be an EFI system partition? How did you dodge my
> nasty partition hack :)

It's not using initialize-harddisk but rather grub-mkrescue and xorriso in order to create the filesystem.

That's because ISO-9660 filesystems are read-only and have to be created *including* the entire content in one go.

> Also, the derivation creates two files alongside the ISO, are those
> actually required 

No.

>or can we make it it return the ISO directly?

I don't know how...

> Impressive work nonetheless! Many users have asked for ISO support for
> use with e.g. hosting providers. And it's really cool to be able to
> create a CDROM/USB, BIOS/UEFI* multi-hybrid at a whim!
> 
> * Soon™

Bug #27689 fixes it a bit if the bootloader used is grub-efi.

However, that image then doesn't work with normal (non-EFI) BIOS and neither does it work with "qemu -hda".

Unfortunately I can't debug the "qemu -hda" problem properly because it seems that when UEFI is in use, "grub linux16" doesn't work any more which means I can't increase the number of lines on screen anymore (also, there's a huge penguin in the way) which means I can't see the entire error message that the guest prints.

How can I see the entire Linux kernel crash message in qemu (UEFI)?